Index: /trunk/LMDZ.GENERIC/libf/phystd/optci.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/optci.F90	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/optci.F90	(revision 253)
@@ -3,7 +3,6 @@
            TMID,PMID,TAUGSURF,QVAR)
 
-
       use radinc_h
-      use radcommon_h, only: gasi, tlimit, wrefVAR, Cmk,tgasref,pfgasref,wnoi
+      use radcommon_h, only: gasi, tlimit, wrefVAR, Cmk,tgasref,pfgasref,wnoi,scalep
       implicit none
 
@@ -31,4 +30,5 @@
 #include "comcstfi.h"
 #include "callkeys.h"
+#include "gases.h"
 
 
@@ -58,5 +58,6 @@
 
       real*8 taugsurf(L_NSPECTI,L_NGAUSS-1)
-      real*8 dco2
+      real*8 DCONT
+      double precision wn_cont, p_cont, T_cont
 
 !     Water mixing ratio variables
@@ -69,5 +70,20 @@
 
 !     variables for k in units m^-1
-      real*8 rho, dz
+      real*8 rho, dz(L_LEVELS)
+
+      integer igas
+
+      !--- Kasting's CIA ----------------------------------------
+      !real*8, parameter :: Ci(L_NSPECTI)=[                         &
+      !     3.8E-5, 1.2E-5, 2.8E-6, 7.6E-7, 4.5E-7, 2.3E-7,    &
+      !     5.4E-7, 1.6E-6, 0.0,                               &
+      !     0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0,            & 
+      !     0.0, 4.0E-7, 4.0E-6, 1.4E-5,    &
+      !     1.0E-5, 1.2E-6, 2.0E-7, 5.0E-8, 3.0E-8, 0.0 ] 
+      !real*8, parameter :: Ti(L_NSPECTI)=[ -2.2, -1.9,             &
+      !     -1.7, -1.7, -1.7, -1.7, -1.7, -1.7,                &
+      !     0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, &
+      !     -1.7,-1.7,-1.7,-1.7,-1.7,-1.7,-1.7, -1.7,0.0 ]
+      !----------------------------------------------------------
 
 !=======================================================================
@@ -75,47 +91,73 @@
 !     spectral interval, NW, and each Gauss point, NG.
 
-      DO NG=1,L_NGAUSS-1
-         do NW=1,L_NSPECTI
-            TAUGSURF(NW,NG) = 0.0D0
-         end do
-      end do
+      taugsurf(:,:) = 0.0
+      dpr(:)        = 0.0
+      lkcoef(:,:)   = 0.0
 
       do K=2,L_LEVELS
          DPR(k) = PLEV(K)-PLEV(K-1)
-
-         rho  = PLEV(K)/(R*TMID(K))
-         dz   = -DPR(k)/(g*rho)
-         !print*,'rho=',rho
-         !print*,'dz=',dz
-
          U(k)   = Cmk*DPR(k)    ! only Cmk line in optci.F
-         ! soon to be replaced by m^-1 !!!
+
+         !--- Kasting's CIA ----------------------------------------
+         !dz(k)=dpr(k)*189.02*TMID(K)/(0.03720*PMID(K))
+         ! this is CO2 path length (in cm) as written by Francois
+         ! delta_z = delta_p * R_specific * T / (g * P)
+         ! But Kasting states that W is in units of _atmosphere_ cm
+         ! So we do
+         !dz(k)=dz(k)*(PMID(K)/1013.25)
+         !dz(k)=dz(k)/100.0 ! in m for SI calc
+         !----------------------------------------------------------
+
+         ! if we have continuum opacities, we need dz
+         dz(k)=dpr(k)*R*TMID(K)/(g*PMID(K))
 
          call tpindex(PMID(K),TMID(K),QVAR(K),pfgasref,tgasref,WREFVAR, &
               LCOEF,MT(K),MP(K),NVAR(K),WRATIO(K))
-
+         
          do LK=1,4
             LKCOEF(K,LK) = LCOEF(LK)
          end do
 
+
          DO NW=1,L_NSPECTI
             do iaer=1,naerkind
-               TAEROS(K,NW,IAER) = TAUAERO(K,IAER)  * QXIAER(K,NW,IAER)
+               TAEROS(K,NW,IAER) = TAUAERO(K,IAER) * QXIAER(K,NW,IAER)
             end do
          END DO
       end do                    ! levels
 
-
       do K=2,L_LEVELS
          do nw=1,L_NSPECTI
  
-             DCO2   = 0.0 ! continuum absorption (no longer used)
-
-             !if(varactive)then
-             !   call water_cont(PMID(K),TMID(K),WRATIO(K),WNOI(nw),DCO2)
-             !endif
-
-           do ng=1,L_NGAUSS-1
-
+            DCONT = 0.0 ! continuum absorption
+
+            ! include H2 continuum
+            do igas=1,ngasmx
+               if(gnom(igas).eq.'H2_')then 
+
+                  wn_cont = dble(wnoi(nw))
+                  T_cont  = dble(TMID(k))
+                  p_cont  = dble(PMID(k)*scalep*gfrac(igas))
+
+                  call interpolateH2H2(wn_cont,T_cont,p_cont,DCONT,.false.)
+
+                  DCONT=DCONT*dz(k)
+
+
+               endif
+            enddo
+
+            !--- Kasting's CIA ----------------------------------------
+            !DCO2   = dz(k)*Ci(nw)*(1.2859*PMID(k)/1000.0)*(TMID(k)/300.)**Ti(nw)
+            !DCO2 = 130*Ci(nw)*(pmid(k)/1013.25)**2*(tmid(k)/300.)**Ti(nw) * dz(k)
+            ! these two have been verified to give the same results
+            !----------------------------------------------------------
+
+            ! Water continuum currently inactive!
+            !if(varactive)then
+            !   call water_cont(PMID(K),TMID(K),WRATIO(K),WNOI(nw),DCO2)
+            !endif
+
+            do ng=1,L_NGAUSS-1
 
 !     Now compute TAUGAS
@@ -125,6 +167,5 @@
 !     the water data range
 
-
-               if (L_REFVAR.eq.1)then ! added by RW for special no variable case
+               if(L_REFVAR.eq.1)then ! added by RW for special no variable case
                   KCOEF(1) = GASI(MT(K),MP(K),1,NW,NG)
                   KCOEF(2) = GASI(MT(K),MP(K)+1,1,NW,NG)
@@ -133,35 +174,36 @@
                else
 
-              KCOEF(1) = GASI(MT(K),MP(K),NVAR(K),NW,NG) + WRATIO(K)*     &
-                   (GASI(MT(K),MP(K),NVAR(K)+1,NW,NG) -                   & 
-                   GASI(MT(K),MP(K),NVAR(K),NW,NG))
-
-               KCOEF(2) = GASI(MT(K),MP(K)+1,NVAR(K),NW,NG) + WRATIO(K)*  &
-                   (GASI(MT(K),MP(K)+1,NVAR(K)+1,NW,NG) -                 &
-                   GASI(MT(K),MP(K)+1,NVAR(K),NW,NG))
-
-             KCOEF(3) = GASI(MT(K)+1,MP(K)+1,NVAR(K),NW,NG) + WRATIO(K)*  &
-                   (GASI(MT(K)+1,MP(K)+1,NVAR(K)+1,NW,NG) -               &
-                   GASI(MT(K)+1,MP(K)+1,NVAR(K),NW,NG))
-
-               KCOEF(4) = GASI(MT(K)+1,MP(K),NVAR(K),NW,NG) + WRATIO(K)*  &
-                   (GASI(MT(K)+1,MP(K),NVAR(K)+1,NW,NG) -                 &
-                   GASI(MT(K)+1,MP(K),NVAR(K),NW,NG))
+                  KCOEF(1) = GASI(MT(K),MP(K),NVAR(K),NW,NG) + WRATIO(K)*     &
+                       (GASI(MT(K),MP(K),NVAR(K)+1,NW,NG) -                   & 
+                       GASI(MT(K),MP(K),NVAR(K),NW,NG))
+
+                  KCOEF(2) = GASI(MT(K),MP(K)+1,NVAR(K),NW,NG) + WRATIO(K)*   &
+                       (GASI(MT(K),MP(K)+1,NVAR(K)+1,NW,NG) -                 &
+                       GASI(MT(K),MP(K)+1,NVAR(K),NW,NG))
+
+                  KCOEF(3) = GASI(MT(K)+1,MP(K)+1,NVAR(K),NW,NG) + WRATIO(K)* &
+                       (GASI(MT(K)+1,MP(K)+1,NVAR(K)+1,NW,NG) -               &
+                       GASI(MT(K)+1,MP(K)+1,NVAR(K),NW,NG))
+
+                  KCOEF(4) = GASI(MT(K)+1,MP(K),NVAR(K),NW,NG) + WRATIO(K)*   &
+                       (GASI(MT(K)+1,MP(K),NVAR(K)+1,NW,NG) -                 &
+                       GASI(MT(K)+1,MP(K),NVAR(K),NW,NG))
                endif
 
 !     Interpolate the gaseous k-coefficients to the requested T,P values
 
-               ANS = LKCOEF(K,1)*KCOEF(1) + LKCOEF(K,2)*KCOEF(2) +        &
+               ANS = LKCOEF(K,1)*KCOEF(1) + LKCOEF(K,2)*KCOEF(2) +            &
                     LKCOEF(K,3)*KCOEF(3) + LKCOEF(K,4)*KCOEF(4)
-
+               
                TAUGAS  = U(k)*ANS
 
-               TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS
-
-               DTAUKI(K,nw,ng) = TAUGAS
+               TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS + DCONT
+               !TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS
+
+               DTAUKI(K,nw,ng) = TAUGAS + DCONT ! For parameterized continuum absorption
+
                do iaer=1,naerkind
-                  DTAUKI(K,nw,ng) = DTAUKI(K,nw,ng) + TAEROS(K,NW,IAER)   &
-                       + DCO2 ! For Kasting CIA
-               end do
+                  DTAUKI(K,nw,ng) = DTAUKI(K,nw,ng) + TAEROS(K,NW,IAER)
+               end do ! a bug was here!
 
             end do
@@ -171,9 +213,9 @@
 
             NG              = L_NGAUSS
-            DTAUKI(K,nw,ng) = 0.0
+            DTAUKI(K,nw,ng) = 0.0 + DCONT ! For parameterized continuum absorption
+
             do iaer=1,naerkind
-               DTAUKI(K,nw,ng) = DTAUKI(K,nw,ng) +  TAEROS(K,NW,IAER)     &
-                    + DCO2 ! For parameterized continuum absorption
-            end do ! a bug was found here!!
+               DTAUKI(K,nw,ng) = DTAUKI(K,nw,ng) +  TAEROS(K,NW,IAER)
+            end do ! a bug was here!
 
          end do
@@ -275,11 +317,11 @@
 
 !-------------------------------------------------------------------------
-    subroutine water_cont(p,T,wratio,nu,DCO2)
+    subroutine water_cont(p,T,wratio,nu,DCONT)
 !   Calculates the continuum opacity for H2O
-!   must check somewhere that it actually _is_ H2O we are using...
+!   NOT CURRENTLY USED
 
       implicit none
 
-      real p, T, wratio, nu, DCO2
+      real p, T, wratio, nu, DCONT
       real h1, h2
 
@@ -287,9 +329,9 @@
       h2 = 1.25e-22 + 1.67e-19*exp(-2.62e-13*nu)
 
-!      DCO2 = h1*h2*p*(p*wratio)**2/(R*T)
-
-      DCO2=0.0 ! to be implemented...
+!      DCONT = h1*h2*p*(p*wratio)**2/(R*T)
+!      DCONT=0.0 ! to be implemented...
 
       return
 
     end subroutine water_cont
+
Index: /trunk/LMDZ.GENERIC/libf/phystd/optcv.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/optcv.F90	(revision 253)
+++ /trunk/LMDZ.GENERIC/libf/phystd/optcv.F90	(revision 253)
@@ -0,0 +1,287 @@
+      SUBROUTINE OPTCV(DTAUV,TAUV,TAUCUMV,PLEV,  &
+          QXVAER,QSVAER,GVAER,WBARV,COSBV,       &
+          TAURAY,TAUAERO,TMID,PMID,TAUGSURF,QVAR)
+
+      use radinc_h
+      use radcommon_h, only: gasv, tlimit, wrefVAR, Cmk, tgasref, pfgasref,wnov,scalep
+
+      implicit none
+
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Calculates shortwave optical constants at each level.
+!     
+!     Authors
+!     -------
+!     Adapted from the NASA Ames code by R. Wordsworth (2009)
+!     
+!==================================================================
+!     
+!     THIS SUBROUTINE SETS THE OPTICAL CONSTANTS IN THE VISUAL  
+!     IT CALCUALTES FOR EACH LAYER, FOR EACH SPECRAL INTERVAL IN THE VISUAL
+!     LAYER: WBAR, DTAU, COSBAR
+!     LEVEL: TAU
+!     
+!     TAUV(L,NW,NG) is the cumulative optical depth at the top of radiation code
+!     layer L. NW is spectral wavelength interval, ng the Gauss point index.
+!     
+!     TLEV(L) - Temperature at the layer boundary
+!     PLEV(L) - Pressure at the layer boundary (i.e. level)
+!     GASV(NT,NPS,NW,NG) - Visual CO2 k-coefficients 
+!     
+!-------------------------------------------------------------------
+
+#include "callkeys.h"
+#include "comcstfi.h"
+#include "gases.h"
+
+      real*8 DTAUV(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      real*8 DTAUKV(L_LEVELS+1,L_NSPECTV,L_NGAUSS)
+      real*8 TAUV(L_NLEVRAD,L_NSPECTV,L_NGAUSS)
+      real*8 TAUCUMV(L_LEVELS,L_NSPECTV,L_NGAUSS)
+      real*8 PLEV(L_LEVELS)
+      real*8 TMID(L_LEVELS), PMID(L_LEVELS)
+      real*8 COSBV(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      real*8 WBARV(L_NLAYRAD,L_NSPECTV,L_NGAUSS)
+      real*8 TAURAY(L_NSPECTV)
+
+!     For aerosols
+      real*8 QXVAER(L_LEVELS+1,L_NSPECTV,NAERKIND)
+      real*8 QSVAER(L_LEVELS+1,L_NSPECTV,NAERKIND)
+      real*8 GVAER(L_LEVELS+1,L_NSPECTV,NAERKIND)
+      real*8 TAUAERO(L_LEVELS+1,NAERKIND)
+      real*8 TAUAEROLK(L_LEVELS+1,L_NSPECTV,NAERKIND)
+      real*8 TAEROS(L_LEVELS,L_NSPECTV,NAERKIND)
+
+      integer L, NW, NG, K, NG1(L_NSPECTV), LK, IAER
+      integer MT(L_LEVELS), MP(L_LEVELS), NP(L_LEVELS)
+      real*8  ANS, TAUGAS
+      real*8  TRAY(L_LEVELS,L_NSPECTV)
+      real*8  DPR(L_LEVELS), U(L_LEVELS)
+      real*8  LCOEF(4), LKCOEF(L_LEVELS,4)
+
+      real*8 taugsurf(L_NSPECTV,L_NGAUSS-1), TRAYAER
+
+!     Water mixing ratio variables
+      real*8 QVAR(L_LEVELS), WRATIO(L_LEVELS)
+      real*8 KCOEF(4)
+      integer NVAR(L_LEVELS)
+
+!     temporary variables for multiple aerosol calculation
+      real*8 atemp, btemp, ctemp
+
+!     variables for k in units m^-1
+      double precision wn_cont, p_cont, T_cont
+      real*8 dz(L_LEVELS), DCONT
+
+      integer igas
+
+!=======================================================================
+!     Determine the total gas opacity throughout the column, for each
+!     spectral interval, NW, and each Gauss point, NG.
+!     Calculate the continuum opacities, i.e., those that do not depend on
+!     NG, the Gauss index.
+
+      taugsurf(:,:) = 0.0
+      dpr(:)        = 0.0
+      lkcoef(:,:)   = 0.0
+
+      do K=2,L_LEVELS
+         DPR(k) = PLEV(K)-PLEV(K-1)
+
+         U(k)   = Cmk*DPR(k)
+
+         ! if we have continuum opacities, we need dz
+         dz(k)  = dpr(k)*R*TMID(K)/(g*PMID(K))
+
+         call tpindex(PMID(K),TMID(K),QVAR(K),pfgasref,tgasref,WREFVAR, &
+              LCOEF,MT(K),MP(K),NVAR(K),WRATIO(K))
+
+         do LK=1,4
+            LKCOEF(K,LK) = LCOEF(LK)
+         end do
+
+         DO NW=1,L_NSPECTV
+            TRAY(K,NW)   = TAURAY(NW) * DPR(K)
+
+            do iaer=1,naerkind
+               TAEROS(K,NW,IAER) = TAUAERO(K,IAER)  * QXVAER(K,NW,IAER)
+            end do
+!     
+
+         END DO
+      end do
+
+!     TRAYAER is Tau RAYleigh scattering, plus AERosol opacity
+
+!     we ignore K=1...
+      do K=2,L_LEVELS
+         do NW=1,L_NSPECTV
+
+            TRAYAER = TRAY(K,NW)
+            do iaer=1,naerkind
+               TRAYAER = TRAYAER + TAEROS(K,NW,IAER)
+            end do
+
+            DCONT = 0.0 ! continuum absorption
+
+            ! include H2 continuum
+            do igas=1,ngasmx
+               if(gnom(igas).eq.'H2_')then 
+
+                  wn_cont = dble(wnov(nw))
+                  T_cont  = dble(TMID(k))
+                  p_cont  = dble(PMID(k)*scalep*gfrac(igas))
+                  call interpolateH2H2(wn_cont,T_cont,p_cont,DCONT,.false.)
+
+                  DCONT=DCONT*dz(k) 
+
+                  if((.not.callgasvis))then
+                     DCONT=0.0
+                  endif
+
+
+               endif
+            enddo
+
+            do NG=1,L_NGAUSS-1
+
+!=======================================================================
+!     Now compute TAUGAS
+!     Interpolate between water mixing ratios
+!     WRATIO = 0.0 if the requested water amount is equal to, or outside the
+!     the water data range
+
+               if (L_REFVAR.eq.1)then ! added by RW for special no variable case
+                  KCOEF(1) = GASV(MT(K),MP(K),1,NW,NG)
+                  KCOEF(2) = GASV(MT(K),MP(K)+1,1,NW,NG)
+                  KCOEF(3) = GASV(MT(K)+1,MP(K)+1,1,NW,NG)
+                  KCOEF(4) = GASV(MT(K)+1,MP(K),1,NW,NG)
+               else
+                  KCOEF(1) = GASV(MT(K),MP(K),NVAR(K),NW,NG) + WRATIO(K)*    &
+                       (GASV(MT(K),MP(K),NVAR(K)+1,NW,NG) -                  &
+                       GASV(MT(K),MP(K),NVAR(K),NW,NG))
+
+                  KCOEF(2) = GASV(MT(K),MP(K)+1,NVAR(K),NW,NG) + WRATIO(K)*  &
+                       (GASV(MT(K),MP(K)+1,NVAR(K)+1,NW,NG) -                &
+                       GASV(MT(K),MP(K)+1,NVAR(K),NW,NG))
+
+                  KCOEF(3) = GASV(MT(K)+1,MP(K)+1,NVAR(K),NW,NG) + WRATIO(K)*&
+                       (GASV(MT(K)+1,MP(K)+1,NVAR(K)+1,NW,NG) -              &
+                       GASV(MT(K)+1,MP(K)+1,NVAR(K),NW,NG))
+
+                  KCOEF(4) = GASV(MT(K)+1,MP(K),NVAR(K),NW,NG) + WRATIO(K)*  &
+                       (GASV(MT(K)+1,MP(K),NVAR(K)+1,NW,NG) -                &
+                       GASV(MT(K)+1,MP(K),NVAR(K),NW,NG))
+               endif
+
+!     Interpolate the gaseous k-coefficients to the requested T,P values
+               
+               ANS = LKCOEF(K,1)*KCOEF(1) + LKCOEF(K,2)*KCOEF(2) +           &
+                    LKCOEF(K,3)*KCOEF(3) + LKCOEF(K,4)*KCOEF(4)
+
+               TAUGAS          = U(k)*ANS
+
+               !TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS
+               TAUGSURF(NW,NG) = TAUGSURF(NW,NG) + TAUGAS + DCONT
+               DTAUKV(K,nw,ng) = TAUGAS + TRAYAER  & ! TRAYAER includes all scattering contributions
+                                 + DCONT             ! for continuum absorption
+
+            end do
+
+
+!     Now fill in the "clear" part of the spectrum (NG = L_NGAUSS),
+!     which holds continuum opacity only
+
+            NG = L_NGAUSS
+            DTAUKV(K,nw,ng) = TRAY(K,NW) + DCONT ! For parameterized continuum absorption
+            do iaer=1,naerkind
+               DTAUKV(K,nw,ng) = DTAUKV(K,nw,ng) + TAEROS(K,NW,IAER)
+!     &                           + DCONT          ! For parameterized continuum absorption
+            end do ! a bug was here!
+
+         end do
+      end do
+
+
+!=======================================================================
+!     Now the full treatment for the layers, where besides the opacity
+!     we need to calculate the scattering albedo and asymmetry factors
+
+      DO NW=1,L_NSPECTV
+         DO K=2,L_LEVELS
+            do iaer=1,naerkind
+              TAUAEROLK(K,NW,IAER) = TAUAERO(K,IAER) * QSVAER(K,NW,IAER)
+            end do
+         ENDDO
+      ENDDO
+      
+
+      DO NW=1,L_NSPECTV
+         DO NG=1,L_NGAUSS
+            DO L=1,L_NLAYRAD-1
+               K              = 2*L+1
+
+               DTAUV(L,nw,ng) = DTAUKV(K,NW,NG)+DTAUKV(K+1,NW,NG)
+
+               atemp=0.
+               btemp=TRAY(K,NW) + TRAY(K+1,NW)
+               ctemp=0.9999*(TRAY(K,NW) + TRAY(K+1,NW))
+               do iaer=1,naerkind
+                  atemp = atemp +                                     &
+                       GVAER(K,NW,IAER)   * TAUAEROLK(K,NW,IAER) +    &
+                       GVAER(K+1,NW,IAER) * TAUAEROLK(K+1,NW,IAER)
+                  btemp = btemp +                                     &
+                       TAUAEROLK(K,NW,IAER) + TAUAEROLK(K+1,NW,IAER)
+                  ctemp = ctemp +                                     &
+                       TAUAEROLK(K,NW,IAER) + TAUAEROLK(K+1,NW,IAER)
+               end do
+
+               COSBV(L,NW,NG) = atemp/btemp
+               WBARV(L,nw,ng) = ctemp/DTAUV(L,nw,ng)
+
+            END DO
+
+!     No vertical averaging on bottom layer
+
+            L              = L_NLAYRAD
+            K              = 2*L+1
+            DTAUV(L,nw,ng) = DTAUKV(K,NW,NG)
+
+            atemp=0.
+            btemp=TRAY(K,NW)
+            ctemp=0.9999*TRAY(K,NW)
+            do iaer=1,naerkind
+               atemp = atemp + GVAER(K,NW,IAER) * TAUAEROLK(K,NW,IAER) 
+               btemp = btemp + TAUAEROLK(K,NW,IAER) 
+               ctemp = ctemp + TAUAEROLK(K,NW,IAER)
+            end do
+            COSBV(L,NW,NG) = atemp/btemp
+            WBARV(L,nw,ng) = ctemp/DTAUV(L,nw,ng)
+
+         END DO                 ! NG gauss point loop
+      END DO                    ! NW spectral loop
+
+
+
+!     Total extinction optical depths
+
+      DO NW=1,L_NSPECTV        
+         DO NG=1,L_NGAUSS       ! full gauss loop
+            TAUV(1,NW,NG)=0.0D0
+            DO L=1,L_NLAYRAD
+               TAUV(L+1,NW,NG)=TAUV(L,NW,NG)+DTAUV(L,NW,NG)
+            END DO
+
+            TAUCUMV(1,NW,NG)=0.0D0
+            DO K=2,L_LEVELS
+               TAUCUMV(K,NW,NG)=TAUCUMV(K-1,NW,NG)+DTAUKV(K,NW,NG)
+            END DO
+         END DO                 ! end full gauss loop
+      END DO
+
+
+      RETURN
+    END SUBROUTINE OPTCV
Index: /trunk/LMDZ.GENERIC/libf/phystd/orbite.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/orbite.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/orbite.F	(revision 253)
@@ -1,32 +1,23 @@
-      SUBROUTINE orbite(pls,pdist_sol,pdecli)
-      IMPLICIT NONE
+      subroutine orbite(pls,pdist_star,pdecli)
+      implicit none
 
-c=======================================================================
-c
-c   Objet:
-c   ------
-c
-c   Distance from sun and declimation as a function of the solar
-c   longitude Ls
-c
-c   Interface:
-c   ----------
-c
-c
-c
-c   Arguments:
-c   ----------
-c
-c   Input:
-c   ------
-c   pls          Ls
-c
-c   Output:
-c   -------
-c   pdist_sol     Distance Sun-Planet in UA
-c   pdecli        declinaison ( en radians )
-c
-c=======================================================================
-c-----------------------------------------------------------------------
+!==================================================================
+!     
+!     Purpose
+!     -------
+!     Distance from star and declination as a function of the stellar
+!     longitude Ls
+!     
+!     Inputs
+!     ------
+!     pls          Ls
+!
+!     Outputs
+!     -------
+!     pdist_star    Distance Star-Planet in UA
+!     pdecli        declinaison ( in radians )
+!
+!=======================================================================
+
 c   Declarations:
 c   -------------
@@ -38,17 +29,17 @@
 c ----------
 
-      REAL pday,pdist_sol,pdecli,pls,i
+      REAL pday,pdist_star,pdecli,pls,i
 
 c-----------------------------------------------------------------------
 
-c Distance Sun-Planet
+c Star-Planet Distance
 
-      pdist_sol=p_elips/(1.+e_elips*cos(pls+timeperi))
+      pdist_star = p_elips/(1.+e_elips*cos(pls+timeperi))
 
-c Solar declination
+c Stellar declination
 
 c ********************* version before 01/01/2000 *******
 
-      pdecli= asin (sin(pls)*sin(obliquit*pi/180.))
+      pdecli = asin (sin(pls)*sin(obliquit*pi/180.))
 
 c ********************* version after 01/01/2000 *******
@@ -58,6 +49,4 @@
 c ******************************************************
 
-
-
       RETURN
       END
Index: /trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 252)
+++ /trunk/LMDZ.GENERIC/libf/phystd/phyetat0.F	(revision 253)
@@ -1,5 +1,5 @@
       SUBROUTINE phyetat0 (fichnom,tab0,Lmodif,nsoil,nq,
      .           day_ini,time,
-     .           tsurf,tsoil,emis,q2,qsurf)
+     .           tsurf,tsoil,emis,q2,qsurf,cloudfrac,totcloudfrac,hice)
       implicit none
 c======================================================================
@@ -39,4 +39,8 @@
       real qsurf(ngridmx,nq) ! tracers on surface
 !      real co2ice(ngridmx) ! co2 ice cover
+      real cloudfrac(ngridmx,nlayermx)
+      real hice(ngridmx), totcloudfrac(ngridmx)
+
+
 
 !======================================================================
@@ -487,4 +491,82 @@
       xmax = MAXVAL(emis)
       PRINT*,'Surface emissivity <emis>:', xmin, xmax
+
+c
+c Cloud fraction (added by BC 2010)
+c
+      ierr = NF_INQ_VARID (nid, "cloudfrac", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Le champ <cloudfrac> est absent'
+      cloudfrac(:,:)=0.5
+!         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, cloudfrac)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, cloudfrac)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Lecture echouee pour <cloudfrac>'
+         CALL abort
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINVAL(cloudfrac)
+      xmax = MAXVAL(cloudfrac)
+      PRINT*,'Cloud fraction <cloudfrac>:', xmin, xmax
+
+
+c
+c Total cloud fraction (added by BC 2010)
+c
+      ierr = NF_INQ_VARID (nid, "totcloudfrac", nvarid)
+!      ierr = NF_INQ_VARID (nid, "totalfrac", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Le champ <totcloudfrac> est absent'
+      totcloudfrac(:)=0.5
+!         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, totcloudfrac)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, totcloudfrac)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Lecture echouee pour <totcloudfrac>'
+         CALL abort
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINVAL(totcloudfrac)
+      xmax = MAXVAL(totcloudfrac)
+      PRINT*,'Cloud fraction <totcloudfrac>:', xmin, xmax
+
+
+
+
+c
+c Height of oceanic ice (added by BC 2010)
+c
+      ierr = NF_INQ_VARID (nid, "hice", nvarid)
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Le champ <hice> est absent'
+         CALL abort
+      ENDIF
+#ifdef NC_DOUBLE
+      ierr = NF_GET_VAR_DOUBLE(nid, nvarid, hice)
+#else
+      ierr = NF_GET_VAR_REAL(nid, nvarid, hice)
+#endif
+      IF (ierr.NE.NF_NOERR) THEN
+         PRINT*, 'phyetat0: Lecture echouee pour <hice>'
+         CALL abort
+      ENDIF
+      xmin = 1.0E+20
+      xmax = -1.0E+20
+      xmin = MINVAL(hice)
+      xmax = MAXVAL(hice)
+      PRINT*,'Height of oceanic ice <hice>:', xmin, xmax
+
+
 c
 c pbl wind variance
@@ -524,11 +606,11 @@
            ELSE
              txt=tnom(iq)
-             if (txt.eq."h2o_vap") then
+!             if (txt.eq."h2o_vap") then
                ! There is no surface tracer for h2o_vap;
                ! "h2o_ice" should be loaded instead
-               txt="h2o_ice"
-               write(*,*) 'phyetat0: loading surface tracer',
-     &                     ' h2o_ice instead of h2o_vap'
-             endif
+!               txt="h2o_ice"
+!               write(*,*) 'phyetat0: loading surface tracer',
+!     &                     ' h2o_ice instead of h2o_vap'
+!             endif
            ENDIF ! of IF (oldtracernames) THEN
            ierr=NF_INQ_VARID(nid,txt,nvarid)
